import waba.sys.*;

/**
  Game properties
  */
public class GamePrp {
  public byte[] gameSpeed;
  public byte[] rank;
  public boolean[] dspCtg;
  public byte left;

  public GamePrp() {
    gameSpeed = new byte[50];
    rank = new byte[50];
    dspCtg = new boolean[9];
    init();
  }

  public void init() {
    for ( int i=49 ; i>=0 ; i-- ) gameSpeed[i] = rank[i] = 30;
    for ( int i=8 ; i>=0 ; i-- ) dspCtg[i] = true;
    left = 3;
  }

  public byte[] writeObject() {
    byte[] bst = new byte[110];
    Vm.copyArray(gameSpeed, 0, bst, 0, 50);
    Vm.copyArray(rank, 0, bst, 50, 50);
    int c = 100;
    for ( int i=8 ; i>=0 ; i--, c++ ) {
      if ( dspCtg[i] ) bst[c] = 1;
      else bst[c] = 0;
    }
    bst[c] = left;
    return bst;
  }

  public void readObject(byte[] bst) {
    Vm.copyArray(bst, 0, gameSpeed, 0, 50);
    Vm.copyArray(bst, 50, rank, 0, 50);
    int c = 100;
    for ( int i=8 ; i>=0 ; i--, c++ ) {
      if ( bst[c] == 1 ) dspCtg[i] = true;
      else dspCtg[i] = false;
    }
    left = bst[c];
  }
}
